# Eva Demo

Hier finden sich ein paar Beispielkonfigurationen, mit denen Eva ausprobiert werden kann. Bei
erstmaliger Einrichtung:

1. Docker installieren/konfigurieren
2. `cp .env.example .env` und Variablen ggf. anpassen
3. `./setup.sh` ausführen um Beispielaufgaben klonen und die in `.env` definierten Umgebungen zu
   bauen. Eigene Umgebungen können in diesem Verzeichnis organisiert werden, siehe z.B. `python3.11`.

Folgende Konfigurationen gibt es:

## Einfach

Mit dieser Konfiguration werden alle Komponenten auf der selben Maschine
gestartet. Die Docker Images für die Umgebungen werden lokal über den Docker Daemon organisiert und
werden nicht in eine Docker Image Registry hochgeladen. Starten mit:

```
docker compose -f docker-compose.simple.yml up
```

| Dienst | URL |
| ------- | ---- |
| Demo | <http://localhost:8501/> |
| Registry | <http://localhost:7777/> |
| RabbitMQ Management | <http://localhost:15672/> |

Mit dem [Demosystem](docs/tests.md#demo) kann Eva ausprobiert werden.

## Docker Image Registry

Diese Konfiguration ist sinnvoll, wenn die Umgebungen nicht auf der Maschine gebaut werden
sollen/können, auf der Eva ausgeführt wird. Zusätzlich lassen sich damit die Umgebungen im laufenden
Betrieb aktualisieren.

Wie bei der einfachen Konfiguration werden alle
Komponenten auf der selben Maschine gestartet. Zusätzlich wird eine Docker Image Registry
hochgefahren, in der die Umgebungen organisiert werden.

1. Docker Image Registry starten: `docker compose -f docker-compose.reg.yml up docker-registry -d`
2. Umgebungen hochladen, die in `setup.sh` gebaut wurden:
`source .env && ./publish.sh $DOCKER_REGISTRY_HOSTNAME:5000 $ENVIRONMENTS`
3. Alles starten: `docker compose -f docker-compose.reg.yml up`

| Dienst | URL |
| ------- | ---- |
| Demo | <http://localhost:8501/> |
| Registry | <http://localhost:7777/> |
| RabbitMQ Management | <http://localhost:15672/> |
| Docker Image Registry | <http://localhost:5000/> bzw. <http://docker.eva.local:5000/> |

## Horizontale Skalierung

Wenn mehrere Maschinen für die Lösungsauswertung verwendet werden sollen, können mit
`docker-compose.dist.yml` die zentralen Dienste (RabbitMQ, Registry, Demosystem, Docker Image
Registry) hochgefahren werden. In diesem Fall genauso starten wie zuvor bei der Konfiguration
"Docker Image Registry".

Auf verschiedenen Maschinen können dann Dispatcher-Instanzen
hochgefahren werden um die Lösungen auszuwerten. So kann ein Dispatcher beispielsweise auf der
aktuellen Maschine hochgefahren werden:

```
docker compose -f docker-compose.node.yml up
```

| Dienst | URL |
| ------- | ---- |
| Demo | <http://localhost:8501/> |
| Registry | <http://localhost:7777/> |
| RabbitMQ Management | <http://localhost:15672/> |
| Docker Image Registry | <http://localhost:5000/> bzw. <http://docker.eva.local:5000/> |
