#!/usr/bin/env bash

set -e

if [ "$#" -lt 2 ]; then
    echo "Usage: $0 remote_prefix dir1 [dir2 [dir3] ...]"
    exit 1
fi

PREFIX=eva/environments
REMOTE_PREFIX=$1

publish() {
    local path=$1
    local env=$(basename $path)
    local image="$REMOTE_PREFIX/$PREFIX/$env:latest"

    docker image tag $PREFIX/$env:latest $image
    docker push $image

    echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
    echo "Image: $image ($path)"
    echo "You can now use this evaluator IN SUBATO AND OTHER SYSTEMS."
    echo "!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!"
}

shift 1
for ENVIRON in "$@"; do
    publish $ENVIRON
done