---
sidebar_position: 5
---


# Umgebungen

:::info
Die Dockerfiles für die Umgebungen befinden sich im Verzeichnis [`environments`](^eva2RepositoryUrl/environments).
:::

## Build

Das Docker Image für die Umgebung im Verzeichnis `environments/<name>` kann mit dem Skript
`environments/build.sh` gebaut werden:

```bash
./build.sh <name> [<tag>]
```

Die Umgebung muss dabei genauso heißen wie das Unterverzeichnis, in dem sich das Dockerfile
befindet. Wenn `tag` leer gelassen wird, wird das Image automatisch mit `latest` getaggt.

## Veröffentlichung

Bisher existiert das Docker Image für die Umgebung nur lokal. Damit das Image produktiv genutzt
werden kann, muss das Image unter `environments/<name>` in die Container Registry auf GitLab
hochgeladen werden:

```bash
./publish.sh <name> [<tag>]
```

:::caution

Je nach Cache-Konfiguration der [Registry](registry.md) kann es etwas dauern, bis Änderungen oder
neue Umgebungen sichtbar werden.

:::

## Hinweise zu Wartbarkeit

Skripte und andere Dateien, die in mehreren Umgebungen verwendet werden, sind im Repository unter
`environments/shared` zu organisieren, damit Redundanzen vermieden werden. Sollte für eine Umgebung
vereinzelt eine Anpassung dieser Skripte nötig sein, sind die angepassten Dateien im Ordner der
Umgebung zu verwalten und von dort zu kopieren. Weitere Hinweise finden sich in der Checkliste im
[build.sh](^eva2RepositoryUrl/environments/build.sh) Skript.
