#ifndef ADS_H
#define ADS_H

#include <stdio.h>
#include <stdbool.h>
#include <stdarg.h>

// structs
typedef struct {
    size_t length;
    char* data;
} CharArray;

typedef struct {
    size_t length;
    short* data;
} ShortArray;

typedef struct {
    size_t length;
    int* data;
} IntArray;

typedef struct {
    size_t length;
    double* data;
} DoubleArray;

typedef struct {
    size_t length;
    bool* data;
} BoolArray;

#ifdef __cplusplus
extern "C" {
#endif

/* Standard C prototypes */

// functions CharArray
CharArray mkCharArray(size_t n);
void initCharArray(CharArray *rs, size_t n);
void copyCharArray(CharArray *src, CharArray *dest);
CharArray duplicateCharArray(CharArray dataArray);
bool equalsCharArray(CharArray a, CharArray b);
void fillCharArrayByData(CharArray dataArray, char data[]);
void fillCharArrayWithZero(CharArray dataArray);
void shuffleCharArray(int seed, CharArray dataArray);
void printCharArray(CharArray dataArray);
void delCharArray(CharArray dataArray);

// functions ShortArray
ShortArray mkShortArray(size_t n);
void initShortArray(ShortArray *rs, size_t n);
ShortArray copyShortArray(ShortArray dataArray);
void fillShortArrayByData(ShortArray dataArray, short data[]);
void fillShortArrayWithZero(ShortArray dataArray);
void shuffleShortArray(int seed, ShortArray dataArray);
void printShortArray(ShortArray dataArray);
void delShortArray(ShortArray dataArray);

// functions IntArray
IntArray mkIntArray(size_t n);
IntArray copyArray(IntArray dataArray);
void fillArrayByData(IntArray dataArray, int data[]);
void fillArrayByIndex(IntArray dataArray);
void fillArrayWithZero(IntArray dataArray);
void swap(IntArray dataArray, int pos1, int pos2);
void shuffleArray(int seed, IntArray dataArray);
void printArray(IntArray dataArray);
void delIntArray(IntArray dataArray);

// functions DoubleArray
DoubleArray mkDoubleArray(size_t n);
DoubleArray copyDoubleArray(DoubleArray dataArray);
void fillDoubleArrayByData(DoubleArray dataArray, double data[]);
void fillDoubleArrayWithZero(DoubleArray dataArray);
void printDoubleArray(DoubleArray dataArray);
void delDoubleArray(DoubleArray dataArray);

// functions BoolArray
BoolArray mkBoolArray(size_t n);
BoolArray copyBoolArray(BoolArray dataArray);
void printBoolArray(BoolArray dataArray);
void delBoolArray(BoolArray dataArray);

CharArray charArrayFromInitalizerlist(int count, ...);

#ifdef __cplusplus
}
#endif

#endif
