#include "CUnit.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "MemoryTest.h"
#include <float.h>
#include <math.h>

double dEpsilon = DBL_EPSILON * 100;
unsigned int errorcount = 0;
unsigned int testcount = 0;
unsigned int speicherAlloc=0;
unsigned int speicherFree=0;
FILE* fp;

bool assertTrueLine(int line,char* message, bool val){
  testcount++;
  if (!val){
    errorcount++;
    fprintf(fp,"true expected: (%d) fail: ",line);
    char* it;
    for (it= message;*it != '\0';it++) {
      switch (*it){
      case '\n': fprintf(fp," ");break;
      case '\"': fprintf(fp,"\\\"");break;
      default: fprintf(fp,"%c",*it);
      }
    }
    //    fprintf(fp," \" type=\"AssertionFailedError\">\n");
    //   fprintf(fp,"       (%d) fail: %s\n",line,message);
    //    fprintf(fp,"    </failure>\n");
  }
  if (errorcount>0) exit (2);
}

bool assertIntEqLine(int line,char* message, int expected, int found){
  testcount++;
  if (expected!=found){
    errorcount++;
    fprintf(fp,"line (%d) expected:&lt;%d&gt; but was:&lt;%d&gt;: ",line, expected,found);
    char* it;
    for (it= message;*it != '\0';it++) {
      switch (*it){
      case '\n': fprintf(fp," ");break;
      case '\"': fprintf(fp,"\\\"");break;
      default: fprintf(fp,"%c",*it);
      }
    }
    //    fprintf(fp,"\" type=\"AssertionFailedError\">\n");
    //fprintf(fp,"    </failure>\n");
    exit(2);
  }
  exit (0);
}

bool assertDoubleEqLine(int line,char* message, double expected, double found){
  testcount++;
  if (fabs(expected - found) > dEpsilon){
      errorcount++;
      fprintf(fp,"expected:&lt;%.20f&gt; but was:&lt;%.20f&gt;\"",expected,found);
      // fprintf(fp,"      (%d) fail: %s, expected %f found %f\n",line,message,expected,found);
      // fprintf(fp,"    </failure>\n");
            fflush(fp);
      exit(2);
  }
  exit(0);
}

bool assertStringEqLine(int line,char* message, char* expected,char* this){
  testcount++;
  bool result = strcmp(expected,this)==0;
  if (!result){
    errorcount++;
    // fprintf(fp,"    <failure  type=\"AssertionFailedError\">\n");
    fprintf(fp,"      (%d) fail: %s, expected <pre><![CDATA[\"%s\"]]>]<![CDATA[]></pre> but found  <pre><![CDATA[\"%s\"]]>]<![CDATA[]></pre>\n",line,message,expected,this);
    //    fprintf(fp,"    </failure>\n");
    fflush(fp);
  }
  if (result) exit(0); else exit(2);
}


void openFile(char* filename){
  fp = fopen(filename, "w");
  if (fp == NULL){
    printf("Error opening the file %s", filename);
    exit(1);
  }
}

void closeFile(){
  fclose(fp);
}



void printStorage(){
  fprintf(fp,"  <storage allocated=\"%d\" free=\"%d\" diff=\"%d\"/>\n",speicherAlloc,speicherFree,speicherAlloc-speicherFree);
}



