package org.subato;
import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import java.util.List;
import java.util.Arrays;
import java.util.Collection;

import org.junit.Before;
import org.junit.Test;


import java.io.*;
import java.nio.file.*;
import java.nio.*;

public class JavaWrapper {
  @Before
  public void setUp() throws Exception {
  }

  static String RESULTS="testresult.xml";

  static String mkC(String cCode,List<String> includes) {
    return "#include <stdio.h>\n#include \"CUnit.h\"\n#include \"MemoryTest.h\"\n"
      +includes.stream().map((x)-> "\n#include \""+x+"\"").reduce("",(x,y)->x+y)
      +"\n\nint main(){\n  openFile(\""+RESULTS+"\");\n  "+cCode+"\n  closeFile();\n  return 0;\n}";
  }

  public static void testC(String cCode,List<String> includes){
    try{
      var cw = new FileWriter("cmain.c");
      cw.write(mkC(cCode, includes));
      cw.close();
      //String cmain = Files.readString(Path.of("cmain.c"));
      //System.out.println(cmain);

      var args = new java.io.File(".").listFiles((dir1, name) -> name.endsWith(".c"));
      String[] cmd  = new String[2+args.length];
      cmd[0]="gcc";

      var i=1;
      for (var arg:args){cmd[i++]=arg.toString();}
      cmd[i++]="-lm";
      Process process = Runtime.getRuntime()
        .exec(cmd);
      BufferedReader output1 = new BufferedReader(new InputStreamReader(process.getErrorStream()));
      String line=null;
      while ((line=output1.readLine())!=null)System.out.println(line);

      Process process2 = Runtime.getRuntime().exec(new String[]{"./a.out"});
      BufferedReader output = new BufferedReader(new InputStreamReader(process2.getInputStream()));
      var resultVal = process2.waitFor();
      String content = Files.readString(Path.of(RESULTS));
      //System.out.println(resultVal+" "+content);
      if (resultVal!=0){
        if (resultVal==139) fail("Segmentation Fault");
        else fail(content);
      }
    }catch (Exception e){
      fail("Exception: "+e);
    }
  }

}


