package de.hsrm.sls.eva.request;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonPOJOBuilder;

@JsonDeserialize(builder = EvaFile.Builder.class)
public class EvaFile {
    private final String path;
    private final String content;

    private EvaFile(String path, String content) {
        this.path = path;
        this.content = content;
    }

    public String getPath() {
        return path;
    }

    public String getContent() {
        return content;
    }

    @JsonPOJOBuilder(withPrefix = "set")
    public static class Builder {
        private String path;
        private String content;

        public Builder setPath(String path) {
            this.path = path;
            return this;
        }

        public Builder setContent(String content) {
            this.content = content;
            return this;
        }

        public EvaFile build() {
            return new EvaFile(path, content);
        }
    }
}
