package de.hsrm.sls.eva.request;

import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonPOJOBuilder;

@JsonDeserialize(builder = RequestedCapability.Builder.class)
public class RequestedCapability {
  private final boolean compile;
  private final boolean test;
  private final boolean style;

  private RequestedCapability(boolean compile, boolean test, boolean style) {
    this.compile = compile;
    this.test = test;
    this.style = style;
  }

  public boolean isCompile() {
    return compile;
  }

  public boolean isTest() {
    return test;
  }

  public boolean isStyle() {
    return style;
  }

  @JsonPOJOBuilder(withPrefix = "set")
  public static class Builder {

    private boolean compile;
    private boolean test;
    private boolean style;

    public Builder setCompile(boolean compile) {
      this.compile = compile;
      return this;
    }

    public Builder setTest(boolean test) {
      this.test = test;
      return this;
    }

    public Builder setStyle(boolean style) {
      this.style = style;
      return this;
    }

    public RequestedCapability build() {
      return new RequestedCapability(compile, test, style);
    }
  }
}
