package de.hsrm.sls.eva.trex.testcase.result;

import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;
import com.fasterxml.jackson.annotation.JsonTypeInfo.As;

@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = As.EXISTING_PROPERTY, property = "type", visible = true)
@JsonSubTypes({
    @JsonSubTypes.Type(value = SuccessResult.class, name = ResultConstants.TYPE_SUCCESS),
    @JsonSubTypes.Type(value = FailureResult.class, name = ResultConstants.TYPE_FAILURE),
    @JsonSubTypes.Type(value = ErrorResult.class, name = ResultConstants.TYPE_ERROR),
    @JsonSubTypes.Type(value = PendingResult.class, name = ResultConstants.TYPE_PENDING),
    @JsonSubTypes.Type(value = StartedResult.class, name = ResultConstants.TYPE_STARTED),
    @JsonSubTypes.Type(value = TimeoutResult.class, name = ResultConstants.TYPE_TIMEOUT),
})
public abstract class Result {
  private String type;

  public Result(String type) {
    this.type = type;
  }

  public String getType() {
    return type;
  }

  public void setType(String type) {
    this.type = type;
  }
}
