import pandas as pd
import streamlit as st
from eva.playground.dispatcher.result import EvalResult


def style_table(result: EvalResult):
    df = pd.DataFrame(
        {
            'severity': [t.severity for t in result.style.report.errors],
            'type': [t.type for t in result.style.report.errors],
            'file_path': [t.file_path for t in result.style.report.errors],
            'pos': [f'({t.line}, {t.column})' for t in result.style.report.errors],
            'message': [t.message for t in result.style.report.errors],
        }
    )
    st.dataframe(
        df,
        column_config={
            'severity': 'Severity',
            'type': 'Type',
            'file_path': 'File',
            'pos': 'Position (line, col)',
            'message': 'Message',
        },
        hide_index=True,
        use_container_width=True,
    )
