from typing import List, Optional

from eva.playground.dispatcher.result import EvalResult
from pydantic import BaseModel


class EvaFile(BaseModel):
    path: str
    content: str


class RequestedCapability(BaseModel):
    compile: bool = False
    test: bool = False
    # coverage: bool = False
    style: bool = False


class EvalRequest(BaseModel):
    stack_ref: str
    solution_files: List[EvaFile]
    include_files: List[EvaFile]
    test_files: List[EvaFile]

    capability: Optional[RequestedCapability]
    params: dict[str, str]


class EvalResponse(BaseModel):
    success: bool
    message: str
    result: Optional[EvalResult]
    version: str
