from typing import Optional

from eva.playground.dispatcher.cexf import Coverage
from eva.playground.dispatcher.stex import StyleReport
from eva.playground.dispatcher.trex import Testsuite
from pydantic import BaseModel


class CompilationResult(BaseModel):
    compiling: bool
    output: str


class TestcaseStats(BaseModel):
    failures: int
    errors: int
    pending: int
    timeouts: int


class TestResult(BaseModel):
    testcases: int
    failed: int
    passed: int
    stats: TestcaseStats
    correctness: float
    leaks: Optional[int]
    output: str
    testsuite: Testsuite
    coverage: Optional[Coverage]


class StyleResult(BaseModel):
    errors: int
    report: StyleReport


class EvalResult(BaseModel):
    compilation: Optional[CompilationResult]
    test: Optional[TestResult]
    style: Optional[StyleResult]
