import typing

from eva.pltform.format.cexf import Coverage
from eva.pltform.format.stex import StyleReport
from eva.pltform.format.trex import Testsuite
from pydantic import BaseModel


class CompilationResult(BaseModel):
    compiling: bool
    output: str


class TestcaseStats(BaseModel):
    failures: int
    errors: int
    pending: int
    timeouts: int


class TestResult(BaseModel):
    testcases: int
    failed: int
    passed: int
    stats: TestcaseStats
    correctness: float
    leaks: typing.Optional[int]
    output: str
    testsuite: Testsuite
    coverage: typing.Optional[Coverage] = None


class StyleResult(BaseModel):
    errors: int
    report: StyleReport


class EvalResult(BaseModel):
    compilation: typing.Optional[CompilationResult]
    test: typing.Optional[TestResult]
    style: typing.Optional[StyleResult]
