from eva.pltform.evaluation.core import (
    EvaluationContext,
    Evaluator,
    EvaluatorCapability,
    ExecutionHandlerConfig,
)
from eva.pltform.evaluation.cpp.compile import CppCompileHandler
from eva.pltform.evaluation.cpp.test import CppTestHandler


class CppEvaluator(Evaluator):
    id = 'cpp'
    supported_envs = 'cpp*'
    default_env = 'cpp13'
    capability = EvaluatorCapability(
        compile=True,
        test=True,
    )

    def setup(self, ctx: EvaluationContext):
        return ExecutionHandlerConfig(compile=CppCompileHandler(), test=CppTestHandler())
