from eva.pltform.evaluation.core import (
    CompilationResult,
    CompileHandler,
    EvaluationContext,
    Evaluator,
)
from eva.pltform.rt import CODE_TIMEOUT


class CWithJavaCompileHandler(CompileHandler):
    def run(self, evaluator: Evaluator, ctx: EvaluationContext) -> CompilationResult:
        r = ctx.env.bash(
            [
                'javac $JAVAC_ARGS -cp $CLASSPATH:$EJUNIT_RUNNER_PATH -d classes',
                '`find . -type f -name "*.java"`',
            ],
            timeout=ctx.opts.compile_timeout,
        )
        r.expect(status_not=[CODE_TIMEOUT])

        compilation_failed = r.retcode != 0
        return CompilationResult(compiling=not compilation_failed, output=r.out())
