from eva.pltform.evaluation.core import (
    EvaluationContext,
    Evaluator,
    EvaluatorCapability,
    ExecutionHandlerConfig,
)
from eva.pltform.evaluation.cwithjava.compile import CWithJavaCompileHandler
from eva.pltform.evaluation.cwithjava.test import CWithJavaTestHandler


class CWithJavaEvaluator(Evaluator):
    id = 'cwithjava'
    supported_envs = 'cwithjava*'
    default_env = 'cwithjava'
    capability = EvaluatorCapability(compile=True, test=True)

    def setup(self, ctx: EvaluationContext):
        return ExecutionHandlerConfig(
            compile=CWithJavaCompileHandler(), test=CWithJavaTestHandler()
        )
