from eva.pltform.evaluation.core import (
    EvaluationContext,
    Evaluator,
    EvaluatorCapability,
    ExecutionHandlerConfig,
)
from eva.pltform.evaluation.elm.test import ElmTestHandler


class ElmEvaluator(Evaluator):
    id = 'elm'
    supported_envs = 'elm*'
    default_env = 'elm'
    capability = EvaluatorCapability(test=True)

    def setup(self, ctx: EvaluationContext):
        return ExecutionHandlerConfig(test=ElmTestHandler())
