from eva.pltform.evaluation.core import (
    EvaluationContext,
    Evaluator,
    EvaluatorCapability,
    ExecutionHandlerConfig,
)
from eva.pltform.evaluation.go.compile import GoCompileHandler
from eva.pltform.evaluation.go.test import GoTestHandler


class GoEvaluator(Evaluator):
    id = 'go'
    supported_envs = 'go*'
    default_env = 'go1.20'
    capability = EvaluatorCapability(compile=True, test=True)

    def setup(self, ctx: EvaluationContext):
        return ExecutionHandlerConfig(compile=GoCompileHandler(), test=GoTestHandler())
