from eva.pltform.evaluation.core import (
    CompilationResult,
    CompileHandler,
    EvaluationContext,
    Evaluator,
)
from eva.pltform.rt import CODE_TIMEOUT


class HaskellCompileHandler(CompileHandler):
    def run(self, evaluator: Evaluator, ctx: EvaluationContext) -> CompilationResult:
        if len(ctx.payload.test_files) > 1:
            raise RuntimeError('this evaluator requires exactly one test file')

        test_paths = [f.path for f in ctx.payload.test_files]
        r = ctx.env.bash(['ghc -o Test', *test_paths])
        r.expect(status_not=[CODE_TIMEOUT])

        compilation_failed = r.retcode != 0
        return CompilationResult(compiling=not compilation_failed, output=r.out())
