from eva.pltform.evaluation.core import (
    EvaluationContext,
    Evaluator,
    EvaluatorCapability,
    ExecutionHandlerConfig,
)
from eva.pltform.evaluation.hs.compile import HaskellCompileHandler
from eva.pltform.evaluation.hs.test import HaskellTestHandler


class HaskellEvaluator(Evaluator):
    id = 'hs'
    supported_envs = 'hs*'
    default_env = 'hs'
    capability = EvaluatorCapability(
        compile=True,
        test=True,
    )

    def setup(self, ctx: EvaluationContext):
        return ExecutionHandlerConfig(compile=HaskellCompileHandler(), test=HaskellTestHandler())
