from eva.pltform.evaluation.core import EvaluationContext


def check_dynamic_asserts(ctx: EvaluationContext):
    changing_assertion_status = [
        t.path for t in ctx.payload.test_files if 'setDefaultAssertionStatus' in t.content
    ]
    if len(changing_assertion_status) != 0:
        raise RuntimeError(
            'Detected a call to setDefaultAssertionStatus in the following test files: '
            f'{changing_assertion_status}. Changing assertion status at runtime is error prone. '
            'Please activate asserts by setting the parameter {JAVA_PARAM_ENABLE_ASSERTIONS} to '
            '"true".'
        )
