from eva.pltform.evaluation.core import EvaluationContext
from eva.pltform.evaluation.java.util import to_fqcn
from eva.pltform.rt import CODE_SUCCESS


def get_testcases(ctx: EvaluationContext, java_args):
    test_fqcns = [to_fqcn(f) for f in ctx.payload.test_files]
    r = ctx.env.bash(
        [
            f'java {java_args} -cp $EJUNIT_LS_PATH:$CLASSPATH:classes',
            'de.hsrm.sls.ejunit.ls.Exporter -o identifiers.txt',
            *test_fqcns,
        ]
    )
    r.expect(status=[CODE_SUCCESS])

    identifiers = ctx.env.read_file('identifiers.txt')
    return identifiers.split('\n')
