from eva.pltform.evaluation.core import (
    EvaluationContext,
    Evaluator,
    EvaluatorCapability,
    ExecutionHandlerConfig,
)
from eva.pltform.evaluation.kotlin.compile import KotlinCompileHandler
from eva.pltform.evaluation.kotlin.test import KotlinTestHandler


class KotlinEvaluator(Evaluator):
    id = 'kotlin'
    supported_envs = 'kotlin*'
    default_env = 'kotlin1.9-java20'
    capability = EvaluatorCapability(compile=True, test=True)

    def setup(self, ctx: EvaluationContext):
        return ExecutionHandlerConfig(compile=KotlinCompileHandler(), test=KotlinTestHandler())
