from eva.pltform.evaluation.core import (
    EvaluationContext,
    Evaluator,
    EvaluatorCapability,
    ExecutionHandlerConfig,
)
from eva.pltform.evaluation.python.test import PythonTestHandler


class PythonEvaluator(Evaluator):
    id = 'python'
    supported_envs = 'python*'
    default_env = 'python3.9'
    capability = EvaluatorCapability(test=True)

    def setup(self, ctx: EvaluationContext):
        return ExecutionHandlerConfig(test=PythonTestHandler())
