from eva.pltform.evaluation.core import (
    CompilationResult,
    CompileHandler,
    EvaluationContext,
    Evaluator,
)
from eva.pltform.rt import CODE_TIMEOUT


class ScalaCompileHandler(CompileHandler):
    def run(self, evaluator: Evaluator, ctx: EvaluationContext) -> CompilationResult:
        ctx.env.mkdir('classes')
        r = ctx.env.bash(
            [
                'scalac -classpath '
                '/test/lib/junit-4.12.jar:/test/lib/hamcrest-core-1.3.jar -d classes '
                '`find . -type f -name "*.scala"`'
            ]
        )
        r.expect(status_not=[CODE_TIMEOUT])

        compilation_failed = r.retcode != 0
        return CompilationResult(compiling=not compilation_failed, output=r.out())
