from eva.pltform.evaluation.core import (
    EvaluationContext,
    Evaluator,
    EvaluatorCapability,
    ExecutionHandlerConfig,
)
from eva.pltform.evaluation.scala.compile import ScalaCompileHandler
from eva.pltform.evaluation.scala.test import ScalaTestHandler


class ScalaEvaluator(Evaluator):
    id = 'scala'
    supported_envs = 'scala*'
    default_env = 'scala'
    capability = EvaluatorCapability(compile=True, test=True)

    def setup(self, ctx: EvaluationContext):
        return ExecutionHandlerConfig(compile=ScalaCompileHandler(), test=ScalaTestHandler())
