from eva.pltform.evaluation.core import (
    EvaluationContext,
    Evaluator,
    EvaluatorCapability,
    ExecutionHandlerConfig,
)
from eva.pltform.evaluation.turing.test import TuringTestHandler


class TuringEvaluator(Evaluator):
    id = 'turing'
    supported_envs = 'turing*'
    default_env = 'turing'
    capability = EvaluatorCapability(test=True)

    def setup(self, ctx: EvaluationContext):
        return ExecutionHandlerConfig(test=TuringTestHandler())
