from typing import List

from pydantic import BaseModel


class StyleError(BaseModel):
    file_path: str
    line: int
    column: int
    message: str
    type: str
    severity: str
    data: dict[str, str] = {}


class StyleReport(BaseModel):
    errors: List[StyleError]
    tool: str
    version: str
