from eva.pltform.evaluation.c import CEvaluator
from eva.pltform.evaluation.cpp import CppEvaluator
from eva.pltform.evaluation.cwithjava import CWithJavaEvaluator
from eva.pltform.evaluation.elm import ElmEvaluator
from eva.pltform.evaluation.evarela import EvarelaEvaluator
from eva.pltform.evaluation.go import GoEvaluator
from eva.pltform.evaluation.hs import HaskellEvaluator
from eva.pltform.evaluation.java import JavaEvaluator
from eva.pltform.evaluation.javaie import JavaIEEvaluator
from eva.pltform.evaluation.js import JsEvaluator
from eva.pltform.evaluation.kotlin import KotlinEvaluator
from eva.pltform.evaluation.mariadb import MariaDBEvaluator
from eva.pltform.evaluation.python import PythonEvaluator
from eva.pltform.evaluation.scala import ScalaEvaluator
from eva.pltform.evaluation.turing import TuringEvaluator


class EvaluatorRegistry:
    _evaluators = None

    def find_by_id(self, evaluator_id):
        return next(iter([a for a in self._load_evaluators() if a.id == evaluator_id]), None)

    def get_evaluators(self):
        return self._load_evaluators()

    def _load_evaluators(self):
        if self._evaluators is None:
            self._evaluators = [
                JavaEvaluator,
                JavaIEEvaluator,
                MariaDBEvaluator,
                CppEvaluator,
                CEvaluator,
                CWithJavaEvaluator,
                GoEvaluator,
                ScalaEvaluator,
                PythonEvaluator,
                JsEvaluator,
                KotlinEvaluator,
                ElmEvaluator,
                HaskellEvaluator,
                EvarelaEvaluator,
                TuringEvaluator,
            ]

        return self._evaluators
