import contextlib
import threading

import loguru
from eva.pltform.rt.core.handle import EnvironmentHandle


class Runtime:
    def __init__(self):
        self.stopped = threading.Event()

    @contextlib.contextmanager
    def create(self, environment_id: str, request_logger: 'loguru.Logger') -> EnvironmentHandle:
        pass

    def describe(self) -> dict[str, str]:
        return {}

    def shutdown(self):
        self.stopped.set()
