from tests.integration.conftest import ARG_BUILD, ARG_ENV, ARG_LOG_LEVEL


# this hook needs to be in the conftest.py of the root dir
# see tests/integration/conftest.py for the code that handles these args
def pytest_addoption(parser):
    parser.addoption(
        ARG_ENV,
        action='store',
        metavar='ENV_ID',
        help="comma separated list of environment ids to test (e.g. 'java19, java20'). By default "
        'all environments are tested.',
    )

    parser.addoption(
        ARG_LOG_LEVEL,
        action='store',
        default='INFO',
        metavar='{DEBUG, INFO, ...} (see loguru log levels)',
        help='set to DEBUG for output from evaluator',
    )

    parser.addoption(
        ARG_BUILD,
        action='store_true',
        default=False,
        help='if set, environments are rebuilt before evaluation',
    )
