from eva.pltform.evaluation.c.util import main_function


def test_main_function1():
    code = """
    unsigned long int factorial(unsigned int x) {
      return x <= 1 ? 1 : x* factorial(x-1);
    }

    int main() {
        factorial(17);
        return 0;
    }
    """

    assert main_function(code)


def test_main_function2():
    code = """
    unsigned long int factorial(unsigned int x) {
      return x <= 1 ? 1 : x* factorial(x-1);
    }

    int main(int argc, char** args) {
        factorial(17);
        return 0;
    }
    """

    assert main_function(code)


def test_main_function3():
    code = """
    unsigned long int factorial(unsigned int x) {
      return x <= 1 ? 1 : x* factorial(x-1);
    }

    int main(int blabla) {
        factorial(17);
        return 0;
    }
    """

    assert main_function(code)


def test_main_function4():
    code = """
    unsigned long int factorial(unsigned int x) {
      return x <= 1 ? 1 : x* factorial(x-1);
    }

    void main() {
        factorial(17);
        return 0;
    }
    """

    assert main_function(code)


def test_main_function5():
    code = """
    unsigned long int factorial(unsigned int x) {
      return x <= 1 ? 1 : x* factorial(x-1);
    }

    int   main(){
        factorial(17);
        return 0;
    }
    """

    assert main_function(code)


def test_main_function6():
    code = """
    unsigned long int factorial(unsigned int x) {
      return x <= 1 ? 1 : x* factorial(x-1);
    }

    int testmain() {
        factorial(17);
        return 0;
    }
    """

    assert not main_function(code)


def test_main_function7():
    code = """
    unsigned long int factorial(unsigned int x) {
      return x <= 1 ? 1 : x* factorial(x-1);
    }

    int Main() {
        factorial(17);
        return 0;
    }
    """

    assert not main_function(code)


def test_main_function8():
    code = """
    unsigned long int factorial(unsigned int x) {
      printf("This is not a main()");
      return x <= 1 ? 1 : x* factorial(x-1);
    }
    """

    assert not main_function(code)
