import pytest
from eva.pltform.evaluation.core import EvaFile, EvalPayload
from tests.integration.util.context import TestContext


@pytest.mark.evaluator('java')
class JavaCompileTest:
    def test_compfailed1(self, ctx: TestContext):
        payload = EvalPayload(
            solution_files=[
                EvaFile(path='Heron.java', content=ctx.fixtures.load('java/compfailed/Heron.java'))
            ],
            include_files=[],
            compile=True,
        )
        result = ctx.eval(payload)
        assert not result.compilation.compiling
        assert 'error: continue outside of loop' in result.compilation.output

    def test_compfailed2(self, ctx: TestContext):
        payload = EvalPayload(
            solution_files=[
                EvaFile(path='Heron.java', content=ctx.fixtures.load('java/compfailed/Heron.java'))
            ],
            test_files=[
                EvaFile(
                    path='HeronTest.java',
                    content=ctx.fixtures.load('java/compfailed/HeronTest.java'),
                )
            ],
            include_files=[],
            compile=True,
            test=True,
        )
        result = ctx.eval(payload)
        assert not result.compilation.compiling
        assert 'error: continue outside of loop' in result.compilation.output
        assert result.test is None
