import pytest
from eva.pltform.evaluation.core import EvaFile, EvalPayload
from tests.integration.util.context import TestContext


@pytest.mark.evaluator('java')
class JavaIncludesTest:

    def test_include(self, ctx: TestContext):
        payload = EvalPayload(
            solution_files=[
                EvaFile(path='AL.java', content=ctx.fixtures.load('java/include/AL.java'))
            ],
            test_files=[
                EvaFile(path='ALTest.java', content=ctx.fixtures.load('java/include/ALTest.java'))
            ],
            include_files=[
                EvaFile(path='List.java', content=ctx.fixtures.load('java/include/List.java'))
            ],
            compile=True,
            test=True,
        )
        result = ctx.eval(payload)
        assert result.compilation.compiling
        assert pytest.approx(result.test.correctness) == 1.0
