import pytest
from eva.pltform.evaluation.core import EvaFile, EvalPayload
from tests.integration.util.context import TestContext


@pytest.mark.evaluator('java')
class JavaPackagesTest:

    def test_package(self, ctx: TestContext):
        payload = EvalPayload(
            solution_files=[
                EvaFile(
                    path='name/panitz/util/AL.java',
                    content=ctx.fixtures.load('java/package/AL.java'),
                )
            ],
            test_files=[
                EvaFile(
                    path='name/panitz/util/ALTest.java',
                    content=ctx.fixtures.load('java/package/ALTest.java'),
                )
            ],
            include_files=[
                EvaFile(
                    path='name/panitz/util/List.java',
                    content=ctx.fixtures.load('java/package/List.java'),
                )
            ],
            compile=True,
            test=True,
        )
        result = ctx.eval(payload)
        assert result.compilation.compiling
        assert pytest.approx(result.test.correctness) == 1.0
