import pytest
from eva.pltform.evaluation.core import EvaFile, EvalPayload
from tests.integration.util.context import TestContext


@pytest.mark.evaluator('java')
class JavaStyleTest:

    def test_style(self, ctx: TestContext):
        payload = EvalPayload(
            solution_files=[
                EvaFile(path='Heron.java', content=ctx.fixtures.load('java/style/Heron.java'))
            ],
            test_files=[],
            include_files=[],
            compile=True,
            style=True,
        )
        result = ctx.eval(payload)
        assert result.compilation.compiling
        assert len(result.style.report.errors) == 1
        assert result.style.report.errors[0].line == 6
        assert result.style.report.errors[0].severity == 'error'
        assert (
            result.style.report.errors[0].type
            == 'com.puppycrawl.tools.checkstyle.checks.blocks.LeftCurlyCheck'
        )
        assert (
            result.style.report.errors[0].message
            == "'{' at column 3 should be on the previous line."
        )
