from eva.pltform.format.cexf import Coverage, LineType


def assert_line_coverage(coverage: Coverage, testcase_id, file_name, expected):
    testcase = next(iter(t for t in coverage.testsuite.testcases if t.id == testcase_id), None)
    file = (
        next(iter(f for f in testcase.files if f.name == file_name), None)
        if testcase is not None
        else None
    )

    msg = f'Coverage for test={testcase_id} and file={file_name} found although not expected'
    assert not (expected is None and file is not None), msg

    if expected is not None:
        msg = f'No coverage for test={testcase_id} and file={file_name} found although expected'
        assert file is not None, msg

        for decision, line_nrs in expected.items():
            matches = (
                [l.nr for l in file.lines if l.type == LineType.LINE and l.decision == decision]
                if file
                else []
            )

            msg = (
                f'wrong line coverage with decision={str(decision)} for test={testcase_id} and '
                f'file={file_name}'
            )
            assert set(line_nrs) == set(matches), msg
