import dataclasses

from eva.pltform.evaluation.core import EvalPayload, EvaluationContext, Evaluator, EvaluatorOptions
from eva.pltform.rt import Runtime
from tests.util import FixtureLoader


@dataclasses.dataclass
class TestContext:
    __test__ = False

    runtime: Runtime
    evaluator: Evaluator
    environment_id: str
    request_logger: 'loguru.Logger'
    opts: EvaluatorOptions = dataclasses.field(default_factory=EvaluatorOptions)
    fixtures: FixtureLoader = None

    def eval(self, payload: EvalPayload):
        with self.runtime.create(self.environment_id, self.request_logger) as env:
            return self.evaluator.eval(
                EvaluationContext(
                    logger=self.request_logger, env=env, opts=self.opts, payload=payload
                )
            )
