import sys

from loguru import logger


def setup_logging(level):
    logger.remove()
    args = {
        'format': '<green>{time}</green> <yellow>[{extra[request_id]}]</yellow> {name} {level} '
        '<level>{message}</level>',
        'level': level,
        'backtrace': False,
        'diagnose': False,
    }

    logger.configure(extra={'request_id': '*'})
    logger.add(sys.stdout, colorize=True, **args)
