import datetime
from typing import List

from cachetools import TTLCache
from eva.registry.environ.model import Environment


class EnvironmentsCache:
    KEY = 'environments'
    last_update: datetime.datetime = None

    def __init__(self, ttl):
        self.cache = TTLCache(maxsize=1, ttl=ttl)

    def expired(self):
        return EnvironmentsCache.KEY not in self.cache

    def get(self) -> List[Environment]:
        return self.cache[EnvironmentsCache.KEY]

    def set(self, evaluators: List[Environment]):
        self.cache[EnvironmentsCache.KEY] = evaluators
        self.last_update = datetime.datetime.now()
