from typing import Optional

from eva.pltform.evaluation.core import EvaluatorCapability
from eva.registry.environ import Environment
from pydantic import BaseModel


class EvaluatorDeclaration(BaseModel):
    id: str
    capability: EvaluatorCapability
    supported_envs: Optional[str]
    excluded_envs: Optional[str]
    default_env: Optional[str]


class EvaluationStack(BaseModel):
    environment: Environment
    evaluator: EvaluatorDeclaration
    ref: str = ''

    def __init__(self, **data):
        super().__init__(**data)
        self.ref = f'{self.evaluator.id}@{self.environment.id}'
