package de.hsrm.sls.cexf.openclover;

import com.atlassian.clover.api.command.ArgProcessor;
import com.atlassian.clover.reporters.Current;
import java.util.List;

public class HelpBuilder {
    public static String buildHelp(Class clazz,
        List<ArgProcessor<? extends Current>> mandatoryArgProcessors,
        List<ArgProcessor<? extends Current>> optionalArgProcessors) {
        final StringBuilder helpMessage = new StringBuilder();
        helpMessage.append("  USAGE: ").append(clazz.getName()).append(" [OPTIONS] PARAMS\n\n");

        helpMessage.append("  PARAMS:\n");
        for (ArgProcessor argProcessor : mandatoryArgProcessors) {
            helpMessage.append(argProcessor.help());
        }

        helpMessage.append("  OPTIONS:\n");
        for (ArgProcessor argProcessor : optionalArgProcessors) {
            helpMessage.append(argProcessor.help());
        }

        return helpMessage.toString();
    }

}