package de.hsrm.sls.ejunit.common;

import java.util.LinkedList;
import java.util.Queue;

public class SlidingBuffer<T> {

    private final Queue<T> buffer = new LinkedList<>();
    private final int maxSize;
    private int truncated = 0;

    public SlidingBuffer(int maxSize) {
        this.maxSize = maxSize;
    }

    public void add(T item) {
        buffer.add(item);
        if (buffer.size() > maxSize) {
            buffer.remove();
            truncated += 1;
        }
    }

    public int getTruncated() {
        return truncated;
    }

    public Queue<T> getBuffer() {
        return buffer;
    }
}
