package de.hsrm.sls.ejunit.common;

import java.lang.annotation.Annotation;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class Test {

    private Class clazz;

    public Test(Class clazz) {
        this.clazz = clazz;
    }

    public Class getClazz() {
        return clazz;
    }

    public void setClazz(Class clazz) {
        this.clazz = clazz;
    }

    public List<String> getMethods() {

        ArrayList<String> methods = new ArrayList<String>();
        for (Method m : clazz.getDeclaredMethods()) {
            if (m.getReturnType() == Void.TYPE && m.getParameterTypes().length == 0) {
                for (Annotation a : m.getAnnotations()) {
                    if (a.annotationType().getCanonicalName().equals("org.junit.Test")) {
                        methods.add(m.getName());
                    }
                }
            }
        }
        Collections.sort(methods);
        return methods;
    }

}
