import static org.junit.Assert.assertEquals;

import de.hsrm.sls.ejunit.common.StdCapture;
import org.junit.Test;

public class StdCaptureTest {

    @Test
    public void test01() {
        var capt = new StdCapture(() -> System.out, (s) -> System.setOut(s), 4096);
        capt.startCapture();
        for (int i = 0; i < 10; i++) {
            System.out.print("A" + i);
            System.out.println("Hi" + i);
        }
        capt.stopCapture();

        assertEquals("""
            A0Hi0
            A1Hi1
            A2Hi2
            A3Hi3
            A4Hi4
            A5Hi5
            A6Hi6
            A7Hi7
            A8Hi8
            A9Hi9
            """, capt.toString());
    }

    @Test
    public void test02() {
        var capt = new StdCapture(() -> System.out, (s) -> System.setOut(s), 6);
        capt.startCapture();
        for (int i = 0; i < 10; i++) {
            System.out.print("A" + i);
            System.out.println("Hi" + i);
        }
        capt.stopCapture();

        assertEquals("""
            [54 chars truncated] ... A9Hi9
            """, capt.toString());
    }

    @Test
    public void test03() {
        var capt = new StdCapture(() -> System.out, (s) -> System.setOut(s), 6);
        capt.startCapture();
        for (int i = 0; i < 10; i++) {
            System.out.print("A" + i);
        }
        capt.stopCapture();

        assertEquals("""
            [14 chars truncated] ... A7A8A9""", capt.toString());
    }
}
