package de.hsrm.sls.ejunit.ie.master;

import de.hsrm.sls.ejunit.common.TestLoader;
import de.hsrm.sls.ejunit.common.UncaughtExceptionHandler;
import de.hsrm.sls.trex.TREXSerializer;

public class Master {

    public static void main(String[] args) {
        Thread.currentThread().setUncaughtExceptionHandler(new UncaughtExceptionHandler());
        var params = RunArgs.parse(args);

        System.out.println("EJUnit (IE) started");
        var workerClient = new WorkerClient(params.getWorkerPath(), params.getTimeout(),
            params.getJacocoAgentPath());
        var testRunner = new DistributedTestRunner(workerClient);
        var tests = new TestLoader().loadTests(params.getTestclasses());
        var testsuite = testRunner.run(tests);

        var serializer = new TREXSerializer(params.getOutPath());
        serializer.serialize(testsuite);

        System.out.println("Finished test run: " + testsuite.getFailures() + " failures, " +
            testsuite.getErrors() + " errors, " +
            testsuite.getTimeouts() + " timeouts, " +
            //result.getIgnoreCount() + " ignored, " +
            (testsuite.getTestcases().size()) + " total. " +
            "Elapsed: " + testsuite.getTotalTime() + " seconds");
    }
}