package de.hsrm.sls.ejunit.ie.master;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertTrue;

import de.hsrm.sls.ejunit.common.TestcaseIdentifier;
import de.hsrm.sls.trex.FailureResult;
import de.hsrm.sls.trex.SuccessResult;
import org.junit.Before;
import org.junit.Test;
import sample.InfiniteLoopPingTest;
import sample.InfiniteThreadPingTest;
import sample.PingTest;

public class WorkerClientTest {

    private WorkerClient wc;

    @Before
    public void setup() {
        wc = new WorkerClient("../worker/build/libs/ejunit-ie-worker.jar", 3, null);
    }

    @Test
    public void testPass() {
        var testcase = wc.runTest(new TestcaseIdentifier(PingTest.class.getName(), "test01"));
        assertTrue(testcase.getResult() instanceof SuccessResult);
    }

    @Test
    public void testFailure() {
        var testcase = wc.runTest(new TestcaseIdentifier(PingTest.class.getName(), "test02"));
        assertTrue(testcase.getResult() instanceof FailureResult);
    }

    @Test
    public void testTimeout1() {
        var testcase = wc.runTest(
            new TestcaseIdentifier(InfiniteThreadPingTest.class.getName(), "test01"));
        assertEquals(null, testcase);
    }

    @Test
    public void testTimeout2() {
        var testcase = wc.runTest(
            new TestcaseIdentifier(InfiniteLoopPingTest.class.getName(), "test01"));
        assertEquals(null, testcase);
    }
}
