package de.hsrm.sls.ejunit.ie.worker;

import de.hsrm.sls.ejunit.common.TestLoader;
import de.hsrm.sls.trex.Testcase;
import de.hsrm.sls.trex.junit.RecordStateRunListener;
import org.junit.runner.JUnitCore;
import org.junit.runner.Request;

public class Runner {
    private int maxOutputSize;

    public Runner(int maxOutputSize) {
        this.maxOutputSize = maxOutputSize;
    }

    public Testcase runTest(String className, String method) {

        var testclass = new TestLoader().getTest(className);
        var recordStateListener = new RecordStateRunListener(maxOutputSize);

        var jUnitCore = new JUnitCore();
        jUnitCore.addListener(recordStateListener);
        jUnitCore.run(Request.method(testclass.getClazz(), method));

        var state = recordStateListener.getRunState();
        var testsuite = state.toTestsuite();

        if (testsuite.getTestcases().size() != 1) {
            throw new RuntimeException(
                "there are zero or more than one testcases in the worker testsuite?");
        }

        return testsuite.getTestcases().get(0);
    }
}
