package de.hsrm.sls.ejunit.ie.worker;

import com.fasterxml.jackson.core.JsonProcessingException;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.datatype.jsr310.JavaTimeModule;
import de.hsrm.sls.trex.Testcase;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;

public class Worker {

    public static void main(String[] args) throws IOException {
        var params = RunArgs.parse(args);

        var runner = new Runner(params.getMaxOutputSize());
        var testcase = runner.runTest(params.getTestclass(), params.getMethod());

        Files.writeString(Paths.get(params.getOutPath()), serializeResponse(testcase));
    }

    public static String serializeResponse(Testcase testcase) {
        try {
            var objectMapper = new ObjectMapper();
            objectMapper.registerModule(new JavaTimeModule());
            return objectMapper.writeValueAsString(testcase);
        } catch (JsonProcessingException e) {
            throw new RuntimeException(e);
        }
    }
}