package de.hsrm.sls.ejunit.ls;

import de.hsrm.sls.ejunit.common.TestLoader;
import de.hsrm.sls.ejunit.common.UncaughtExceptionHandler;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.ArrayList;
import java.util.stream.Collectors;

public class Exporter {

    public static void main(String[] args) {
        Thread.setDefaultUncaughtExceptionHandler(new UncaughtExceptionHandler());
        var params = RunArgs.parse(args);

        var tests = new TestLoader().loadTests(params.getTestclasses());
        var s = new ArrayList<String>();
        for(var t : tests) {
            for (var m : t.getMethods()) {
                s.add(t.getClazz().getName() + "#" + m);
            }
        }

        System.out.println("EJUnit (ls): %s test methods from %s test classes found.".formatted(s.size(), params.getTestclasses().length));
        var txt = s.stream().collect(Collectors.joining("\n"));
        try {
            Files.writeString(Path.of(params.getOutPath()), txt);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
}
