package de.hsrm.sls.ejunit.mono.filter;

import de.hsrm.sls.ejunit.common.TestcaseIdentifier;
import java.util.List;
import org.junit.runner.Computer;
import org.junit.runner.Runner;
import org.junit.runners.BlockJUnit4ClassRunner;
import org.junit.runners.model.FrameworkMethod;
import org.junit.runners.model.InitializationError;
import org.junit.runners.model.RunnerBuilder;


public class FilteringComputer extends Computer {

    private final List<TestcaseIdentifier> identifiers;

    public FilteringComputer(List<TestcaseIdentifier> identifiers) {
        this.identifiers = identifiers;
    }

    protected Runner getRunner(RunnerBuilder builder, Class<?> testClass) throws Throwable {
        return new CustomRunner(testClass);
    }


    private class CustomRunner extends BlockJUnit4ClassRunner {

        public CustomRunner(Class<?> klass) throws InitializationError {
            super(klass);
        }

        @Override
        protected List<FrameworkMethod> computeTestMethods() {
            var methods = super.computeTestMethods();
            var filterMethods = identifiers.stream()
                .filter(identifier -> identifier.className().equals(getTestClass().getName()))
                .map(TestcaseIdentifier::methodName)
                .toList();

            return methods.stream().filter(m -> filterMethods.contains(m.getName())).toList();
        }
    }
}
