package de.hsrm.sls.trex;

import com.fasterxml.jackson.annotation.JsonSubTypes;
import com.fasterxml.jackson.annotation.JsonTypeInfo;

@JsonTypeInfo(use = JsonTypeInfo.Id.NAME, include = JsonTypeInfo.As.PROPERTY, property = "type", visible = true)
@JsonSubTypes({
    @JsonSubTypes.Type(value = SuccessResult.class, name = "success"),
    @JsonSubTypes.Type(value = FailureResult.class, name = "failure"),
    @JsonSubTypes.Type(value = ErrorResult.class, name = "error"),
    @JsonSubTypes.Type(value = PendingResult.class, name = "pending"),
    @JsonSubTypes.Type(value = StartedResult.class, name = "started"),
    @JsonSubTypes.Type(value = TimeoutResult.class, name = "timeout"),
})
public class Result {

    private String type;

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }
}
