#!/bin/bash
# Kill MariaDB processes spawned by MariaDB4j that were not removed automatically
# (i.e. by killing the test suite)

COMMAND_PATH="/tmp/MariaDB4j"

pids=$(ps axo pid=,cmd= | grep " $COMMAND_PATH" | awk '{print $1}')

if [ -z "$pids" ]; then
    echo "No processes found starting with $COMMAND_PATH."
else
    for pid in $pids; do
        kill -9 $pid 2>/dev/null
        echo "Killed process PID: $pid"
    done
fi