package de.hsrm.sls.sqlunit.evaluation;

import de.hsrm.sls.sqlunit.evaluation.MariaDBParser.SqlStatementContext;
import java.util.ArrayList;
import java.util.List;
import org.antlr.v4.runtime.CharStream;
import org.antlr.v4.runtime.misc.Interval;

class ExtractStatementsListener extends MariaDBParserBaseListener {
    private List<String> statements = new ArrayList<>();
    private CharStream input;

    public ExtractStatementsListener(CharStream input) {
        this.input = input;
    }

    @Override
    public void enterSqlStatement(SqlStatementContext ctx) {
        int a = ctx.start.getStartIndex();
        int b = ctx.stop.getStopIndex();
        var interval = new Interval(a,b);

        statements.add(input.getText(interval));
    }

    public List<String> getStatements() {
        return statements;
    }
}
