package de.hsrm.sls.sqlunit.segment;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Pattern;

public class SegmentParser {

  public List<Segment> parse(String cs) {
    var segments = new ArrayList<Segment>();

    var pattern = Pattern.compile("^--\\s*QUERY\\s*([a-zA-Z0-9]+):?\\s*$", Pattern.MULTILINE);
    var matcher = pattern.matcher(cs);
    var matches = matcher.results().toList();

    for (var i = 0; i < matches.size(); i++) {
      var match = matches.get(i);
      var nextMatch = i + 1 < matches.size() ? matches.get(i + 1) : null;

      var start = match.end();
      var end = nextMatch != null ? nextMatch.start() : cs.length();
      var s = cs.substring(start, end);

      var id = match.group(1);
      segments.add(new Segment(id, s.trim()));
    }

    return segments;
  }

}
