package de.hsrm.sls.sqlunit.trex;

import java.time.Duration;
import java.time.LocalDateTime;
import java.time.ZoneOffset;

public class Testcase {

    private String className;
    private String name;
    private LocalDateTime startedAt;
    private LocalDateTime finishedAt;
    private String stdout;
    private String stderr;
    private Result result;

    public Testcase(String className, String name) {
        this.className = className;
        this.name = name;
        this.result = new PendingResult();
    }

    public Testcase() {
    }

    public String getClassName() {
        return className;
    }

    public void setClassName(String className) {
        this.className = className;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public LocalDateTime getStartedAt() {
        return startedAt;
    }

    public void setStartedAt(LocalDateTime startedAt) {
        this.startedAt = startedAt;
    }

    public LocalDateTime getFinishedAt() {
        return finishedAt;
    }

    public void setFinishedAt(LocalDateTime finishedAt) {
        this.finishedAt = finishedAt;
    }

    public String getStdout() {
        return stdout;
    }

    public void setStdout(String stdout) {
        this.stdout = stdout;
    }

    public String getStderr() {
        return stderr;
    }

    public void setStderr(String stderr) {
        this.stderr = stderr;
    }

    public Result getResult() {
        return result;
    }

    public void setResult(Result result) {
        this.result = result;
    }

    public Duration getDuration() {
        return Duration.between(startedAt.toInstant(ZoneOffset.UTC),
            finishedAt.toInstant(ZoneOffset.UTC));
    }

    public double getTotalTime() {
        final double ONE_SECOND = 1000.0;
        return getDuration().toMillis() / ONE_SECOND;
    }
}
