package de.hsrm.sls.sqlunit.trex;

import static org.junit.Assert.assertEquals;

import java.time.LocalDateTime;
import org.junit.Test;

public class TREXSerializerTest {
    @Test
    public void test1() {
        var testsuite = new Testsuite();
        testsuite.setStartedAt(LocalDateTime.of(2024, 4, 16, 22, 7, 0));
        testsuite.setFinishedAt(LocalDateTime.of(2024, 4, 16, 22, 8, 0));

        var testcase = new Testcase();
        testcase.setName("q1");

        var result = new FailureResult();
        result.setMessage("Moin");
        result.setDetails("""
erwartet:
[ {
  "p_nr" : "P001",
  "vorname" : "Hape",
  "name" : "Kerkeling"
} ]
aber Ergebnis ist:
[ ]
""");
        testcase.setResult(result);

        testsuite.getTestcases().add(testcase);

        var serializer = new TREXSerializer();
        var xml = serializer.serialize(testsuite);
        assertEquals("""
            <?xml version="1.0" encoding="UTF-8"?>
            <testsuite time="60.0" timestamp="2024-04-16T22:07:00">
              <testcase classname="" name="q1">
                <failure message="Moin"><![CDATA[erwartet:
            [ {
              "p_nr" : "P001",
              "vorname" : "Hape",
              "name" : "Kerkeling"
            } ]
            aber Ergebnis ist:
            [ ]
            ]]></failure>
                <system-out><![CDATA[]]></system-out>
                <system-err><![CDATA[]]></system-err>
              </testcase>
              <system-out><![CDATA[]]></system-out>
              <system-err><![CDATA[]]></system-err>
            </testsuite>
            """, xml);
    }
}
