#!/bin/bash

VERSION="$1"

echo $VERSION > VERSION

# don't update package metadata when building for test (since that would require poetry)
if [[ "$2" != "--test" ]]; then
    # PEP440 does not support semver
    PEP440_VERSION="${VERSION%%-*}"
    sed -i'' "s/^version = \".*\"/version = \"$PEP440_VERSION\"/g" "eva.pltform/pyproject.toml"
    sed -i'' "s/^version = \".*\"/version = \"$PEP440_VERSION\"/g" "eva.dispatcher/pyproject.toml"
    sed -i'' "s/^version = \".*\"/version = \"$PEP440_VERSION\"/g" "eva.registry/pyproject.toml"
    sed -i'' "s/^version = \".*\"/version = \"$PEP440_VERSION\"/g" "eva.playground/pyproject.toml"

    # update lock files, see issue #30
    poetry update eva-pltform --directory eva.registry
    poetry update eva-pltform --directory eva.dispatcher

    sed -i'' "s/VERSION = \".*\"/VERSION = \"$VERSION\"/g" "eva-java/src/main/java/de/hsrm/sls/eva/EvaConstants.java"
    sed -i'' "s/^version '.*'/version '$VERSION-SNAPSHOT'/g" "eva-java/build.gradle"
fi

sed -i'' "s/VERSION = '.*'/VERSION = '$VERSION'/g" "eva.dispatcher/eva/dispatcher/const.py"
sed -i'' "s/VERSION = '.*'/VERSION = '$VERSION'/g" "eva.playground/eva/playground/const.py"