from typing import List

from pydantic import BaseModel


class EvaFile(BaseModel):
    path: str
    content: str


class EvalPayload(BaseModel):
    solution_files: List[EvaFile]
    include_files: List[EvaFile] = []
    test_files: List[EvaFile] = []

    compile: bool = False
    test: bool = False
    style: bool = False

    params: dict[str, str] = {}
